import { convertToLineNodes } from '.';
const blankRegExp = /^(.*?)\[(\s+)\](.*)$/;
const createBlankNode = (text) => ({
    type: 'blank',
    text
});
export const BlankNodeParser = (text, { nested, quoted }, next) => {
    if (nested)
        return next();
    const blankMatch = text.match(blankRegExp);
    if (blankMatch === null)
        return next();
    const [, left, target, right] = blankMatch;
    return [
        ...convertToLineNodes(left, { nested, quoted }),
        createBlankNode(target),
        ...convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=BlankNode.js.map