import { convertToLineNodes } from '.';
const formulaWithTailHalfSpaceRegExp = /^(.*?)\[\$ (.+?) \](.*)$/;
const formulaRegExp = /^(.*?)\[\$ ([^\]]+)\](.*)$/;
const createFormulaNode = (formula) => ({
    type: 'formula',
    formula
});
export const FormulaNodeParser = (text, { nested, quoted }, next) => {
    var _a;
    if (nested)
        return next();
    const hashTagMatch = (_a = text.match(formulaWithTailHalfSpaceRegExp)) !== null && _a !== void 0 ? _a : text.match(formulaRegExp);
    if (hashTagMatch === null)
        return next();
    const [, left, target, right] = hashTagMatch;
    return [
        ...convertToLineNodes(left, { nested, quoted }),
        createFormulaNode(target),
        ...convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=FormulaNode.js.map