import { convertToLineNodes } from '.';
const internalLinkRegExp = /^(.*?)\[(\/?[^[\]]+)\](.*)$/;
const createInternalLinkNode = (href) => ({
    type: 'link',
    pathType: /^\/.*$/.test(href) ? 'root' : 'relative',
    href,
    content: ''
});
export const InternalLinkNodeParser = (text, { nested, quoted }, next) => {
    const internalLinkMatch = text.match(internalLinkRegExp);
    if (internalLinkMatch === null)
        return next();
    const [, left, target, right] = internalLinkMatch;
    return [
        ...convertToLineNodes(left, { nested, quoted }),
        createInternalLinkNode(target),
        ...convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=InternalLinkNode.js.map