import { convertToLineNodes } from '../';
import { createExternalLinkNode } from './ExternalLinkNode';
import { createImageNode } from './ImageNode';
const urlRegExp = /^(?<left>.*?)\[(?<href>https?:\/\/[^\s\]]+)(?<content>)\](?<right>.*)$/;
const leftUrlRegExp = /^(?<left>.*?)\[(?<href>https?:\/\/[^\s\]]+)\s+(?<content>[^\]]*[^\s])\](?<right>.*)$/;
const rightUrlRegExp = /^(?<left>.*?)\[(?<content>[^\]]*[^\s])\s+(?<href>https?:\/\/[^\s\]]+)\](?<right>.*)$/;
const httpRegExp = /^(?<left>.*?\s)?(?<href>https?:\/\/[^\s\]]+)(?<content>)(?<right>.*)$/;
const isUrlMatch = (obj) => { var _a; return ((_a = obj === null || obj === void 0 ? void 0 : obj.groups) === null || _a === void 0 ? void 0 : _a.href) !== undefined; };
const isUrl = (text) => /^https?:\/\/[^\s\]]+$/.test(text);
const isImageUrl = (text) => /^https?:\/\/[^\s\]]+\.(png|jpe?g|gif|svg)(\?[^\]\s]+)?$/i.test(text) ||
    isGyazoImageUrl(text);
const isGyazoImageUrl = (text) => /^https?:\/\/([0-9a-z-]\.)?gyazo\.com\/[0-9a-f]{32}(\/raw)?$/.test(text);
const createUrlNode = (href, content) => {
    if (!(isUrl(content) && isImageUrl(content)) && !isImageUrl(href)) {
        return createExternalLinkNode(href, content);
    }
    if (isImageUrl(content))
        [href, content] = [content, href];
    return createImageNode(href, content);
};
export const UrlNodeParser = (text, { nested, quoted }, next) => {
    var _a, _b, _c;
    const UrlMatch = (_c = (_b = (_a = text.match(urlRegExp)) !== null && _a !== void 0 ? _a : text.match(leftUrlRegExp)) !== null && _b !== void 0 ? _b : text.match(rightUrlRegExp)) !== null && _c !== void 0 ? _c : text.match(httpRegExp);
    if (!isUrlMatch(UrlMatch))
        return next();
    const { left, href, content, right } = UrlMatch.groups;
    return [
        ...convertToLineNodes(left, { nested, quoted }),
        createUrlNode(href, content),
        ...convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=index.js.map