import { QuoteNodeParser } from './QuoteNode';
import { HelpfeelNodeParser } from './HelpfeelNode';
import { StrongImageNodeParser } from './StrongImageNode';
import { StrongIconNodeParser } from './StrongIconNode';
import { StrongNodeParser } from './StrongNode';
import { FormulaNodeParser } from './FormulaNode';
import { DecorationNodeParser } from './DecorationNode';
import { CodeNodeParser } from './CodeNode';
import { BlankNodeParser } from './BlankNode';
import { UrlNodeParser } from './UrlNode';
import { GoogleMapNodeParser } from './GoogleMapNode';
import { InternalLinkNodeParser } from './InternalLinkNode';
import { IconNodeParser } from './IconNode';
import { HashTagNodeParser } from './HashTagNode';
import { PlainNodeParser } from './PlainNode';
const FalsyEliminator = (text, _opt, next) => {
    if (text === '')
        return [];
    return next();
};
const combineNodeParsers = (...parsers) => (text = '', opt = { nested: false, quoted: false }) => parsers.reduceRight((acc, parser) => () => parser(text, opt, acc), () => PlainNodeParser(text))();
export const convertToLineNodes = combineNodeParsers(FalsyEliminator, QuoteNodeParser, HelpfeelNodeParser, CodeNodeParser, FormulaNodeParser, BlankNodeParser, StrongImageNodeParser, StrongIconNodeParser, StrongNodeParser, DecorationNodeParser, UrlNodeParser, IconNodeParser, GoogleMapNodeParser, InternalLinkNodeParser, HashTagNodeParser);
//# sourceMappingURL=index.js.map