"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlankNodeParser = void 0;
const _1 = require(".");
const blankRegExp = /^(.*?)\[(\s+)\](.*)$/;
const createBlankNode = (text) => ({
    type: 'blank',
    text
});
exports.BlankNodeParser = (text, { nested, quoted }, next) => {
    if (nested)
        return next();
    const blankMatch = text.match(blankRegExp);
    if (blankMatch === null)
        return next();
    const [, left, target, right] = blankMatch;
    return [
        ..._1.convertToLineNodes(left, { nested, quoted }),
        createBlankNode(target),
        ..._1.convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=BlankNode.js.map