"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuoteNodeParser = void 0;
const _1 = require(".");
const quoteRegExp = /^>(.*)$/;
const createQuoteNode = (text) => ({
    type: 'quote',
    nodes: _1.convertToLineNodes(text, { nested: false, quoted: true })
});
exports.QuoteNodeParser = (text, { nested, quoted }, next) => {
    if (nested || quoted)
        return next();
    const quoteMatch = text.match(quoteRegExp);
    if (quoteMatch === null)
        return next();
    const [, target] = quoteMatch;
    return [createQuoteNode(target)];
};
//# sourceMappingURL=QuoteNode.js.map