"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StrongIconNodeParser = void 0;
const _1 = require(".");
const iconRegExp = /^(.*?)\[\[([^[\]]*)\.icon(\*(\d+))?\]\](.*)$/;
const createStrongIconNode = (path) => ({
    type: 'strongIcon',
    pathType: /^\//.test(path) ? 'root' : 'relative',
    path
});
exports.StrongIconNodeParser = (text, { nested, quoted }, next) => {
    if (nested)
        return next();
    const iconMatch = text.match(iconRegExp);
    if (iconMatch === null)
        return next();
    const [, left, path, , num = '1', right] = iconMatch;
    const iconNode = createStrongIconNode(path);
    return [
        ..._1.convertToLineNodes(left, { nested, quoted }),
        ...new Array(parseInt(num, 10)).fill(iconNode),
        ..._1.convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=StrongIconNode.js.map