"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StrongImageNodeParser = void 0;
const _1 = require(".");
const strongImageRegExp = /^(?<left>.*?)\[\[(?<src>https?:\/\/[^\s\]]+\.(png|jpe?g|gif|svg))\]\](?<right>.*)$/i;
const gyazoStrongImageRegExp = /^(?<left>.*?)\[\[(?<src>https?:\/\/([0-9a-z-]+\.)?gyazo\.com\/[0-9a-f]{32})\]\](?<right>.*)$/;
const isStrongImageMatch = (obj) => { var _a; return ((_a = obj === null || obj === void 0 ? void 0 : obj.groups) === null || _a === void 0 ? void 0 : _a.src) !== undefined; };
const createStrongImageNode = (src) => ({
    type: 'strongImage',
    src
});
exports.StrongImageNodeParser = (text, { nested, quoted }, next) => {
    var _a;
    if (nested)
        return next();
    const StrongImageMatch = (_a = text.match(strongImageRegExp)) !== null && _a !== void 0 ? _a : text.match(gyazoStrongImageRegExp);
    if (!isStrongImageMatch(StrongImageMatch))
        return next();
    const { left, src, right } = StrongImageMatch.groups;
    const isGyazoImage = /https?:\/\/([0-9a-z-]+\.)?gyazo\.com\/[0-9a-f]{32}/.test(src);
    return [
        ..._1.convertToLineNodes(left, { nested, quoted }),
        createStrongImageNode(src + (isGyazoImage ? '/thumb/1000' : '')),
        ..._1.convertToLineNodes(right, { nested, quoted })
    ];
};
//# sourceMappingURL=StrongImageNode.js.map